package monnethic.mobile.restApi;

import org.json.JSONObject;

import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import monnethic.mobile.database.User;

public class UserApiHandler {

    public JSONObject registerUser(User u){ //return JSON with session ID
        HttpCallHandler httpCallHandler = new HttpCallHandler();
        try{
            String url = Config.USER_REGISTER;
            Map<String, String> map = new HashMap<>();

            map.put("name",u.getName());
            map.put("firstname",u.getFirstname());
            map.put("email",u.getEmail());
            map.put("phone",u.getPhone());
            map.put("association",u.getAssociation());
            map.put("password",u.getPassword());

            String responseCall = httpCallHandler.postHttp(new URL(url), map);
            JSONObject jsonObject = new JSONObject(responseCall);
            u.setUser_hash(jsonObject.getString("user_hash"));

            JSONObject jsonReturn = new JSONObject();
            jsonReturn.put("user_hash",u.getUser_hash());
            //jsonReturn.put("session_id",jsonObject.getString("session_id")); //TODO
            jsonReturn.put("session_id",jsonObject.getString("0"));

            return jsonReturn;
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    public JSONObject loginUser(User u){ //return JSON with session ID
        HttpCallHandler httpCallHandler = new HttpCallHandler();
        try{
            String url = Config.USER_LOGIN;
            Map<String, String> map = new HashMap<>();
            map.put("email",u.getEmail());
            map.put("password",u.getPassword());

            String responseCall = httpCallHandler.postHttp(new URL(url), map);
            JSONObject jsonObject = new JSONObject(responseCall);
            u.setUser_hash(jsonObject.getString("user_hash"));


            JSONObject jsonReturn = new JSONObject();
            jsonReturn.put("status",jsonObject.getString("status"));
            jsonReturn.put("user_hash",u.getUser_hash());
            //jsonReturn.put("session_id",jsonObject.getString("session_id")); //TODO
            jsonReturn.put("session_id",jsonObject.getString("0"));

            return jsonReturn;
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    public Boolean checkUser(String email){
        HttpCallHandler httpCallHandler = new HttpCallHandler();
        Boolean response=false;
        try{
            String url = Config.USER_GET+"?user_email="+email;
            String responseCall = httpCallHandler.getHttp(new URL(url));
            response = new JSONObject(responseCall).getBoolean("response");
        }catch (Exception e){
            e.printStackTrace();
        }
        return response;
    }

}
