package monnethic.mobile.transaction;

import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.example.monnthic.monnethicmobile.R;
import com.j256.ormlite.stmt.query.In;

import java.math.BigInteger;

import monnethic.mobile.homepage.InputController;
import monnethic.mobile.restApi.TransactionApiHandler;

public class TransactionActivity extends AppCompatActivity {
    private String wallet_hash;
    private String user_hash;
    private String user_password;
    private String session_id;
    private EditText addressDestination;
    private EditText amountEditText;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_transaction);
        addressDestination = findViewById(R.id.destination_address);
        amountEditText = findViewById(R.id.amount);
        Button buttonCancel = findViewById(R.id.btn_cancel);
        Button buttonOk = findViewById(R.id.btn_send);

        Intent intent = getIntent();
        user_hash = intent.getStringExtra("USER_HASH");
        user_password = intent.getStringExtra("USER_PWD");
        session_id = intent.getStringExtra("SESSION_ID");
        wallet_hash = intent.getStringExtra("WALLET_HASH");

        buttonCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });

        buttonOk.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                sendTransaction();
            }
        });
    }

    public void sendTransaction(){
        if(InputController.isEmptyEdit(addressDestination)){
            Toast.makeText(this, "No destination address", Toast.LENGTH_SHORT).show();
        } else if(InputController.isEmptyEdit(amountEditText)) {
            Toast.makeText(this, "No amount", Toast.LENGTH_SHORT).show();
        } else {
            String wallet_dest = addressDestination.getText().toString();
            String amount = amountEditText.getText().toString();
            SendingTransaction sendingTransaction = new SendingTransaction(user_hash,user_password,wallet_hash,wallet_dest,amount,"gonette");
            try {
                String transaction_hash = new TransactionTask().execute(sendingTransaction).get();
                if(transaction_hash!=null){
                    Toast.makeText(this, "transaction id : "+transaction_hash, Toast.LENGTH_LONG).show();
                } else {
                    Toast.makeText(this, "couldn't get transaction id", Toast.LENGTH_SHORT).show();
                }
            } catch (Exception e){
                e.printStackTrace();
            }
            finish();
        }
    }

    @Override
    protected void onStop() {
        super.onStop();  // Always call the superclass method first
        Toast.makeText(getApplicationContext(), "onStop called", Toast.LENGTH_LONG).show();
    }

    private class TransactionTask extends AsyncTask<SendingTransaction,String,String> {

        @Override
        protected String doInBackground(SendingTransaction... sendingTransactions) {
            try{
                TransactionApiHandler transactionApiHandler = new TransactionApiHandler();
                return transactionApiHandler.doTransaction(sendingTransactions[0]);
            }catch (Exception e){
                e.printStackTrace();
            }
            return null;
        }
    }

}
